DECLARE
  l_new_application_type_id trainingmgr.xx_plan_app_types.id%TYPE;
  l_upgrade_application_type_id trainingmgr.xx_plan_app_types.id%TYPE;
  l_harry_application_id trainingmgr.xx_plan_apps.id%TYPE;
  l_darth_application_id trainingmgr.xx_plan_apps.id%TYPE;
  l_frodo_application_id trainingmgr.xx_plan_apps.id%TYPE;
  l_harry_detail_id trainingmgr.xx_plan_app_details.id%TYPE;
  l_darth_detail_id trainingmgr.xx_plan_app_details.id%TYPE;
  l_frodo_detail_id trainingmgr.xx_plan_app_details.id%TYPE;
  
BEGIN
  l_new_application_type_id := trainingmgr.xx_plan_app.create_application_type (
    p_title => 'New'
  , p_price => 20
  , p_description => 'Construction of new structure.'
  );
  
  l_upgrade_application_type_id := trainingmgr.xx_plan_app.create_application_type (
    p_title => 'Upgrade'
  , p_price => 10
  , p_description => 'Upgrade to existing structure.'
  );
  
  l_harry_application_id := trainingmgr.xx_plan_app.create_new_application (
    p_application_type_id => l_upgrade_application_type_id
  );
  
  l_harry_detail_id := trainingmgr.xx_plan_app.update_application_data(
    p_application_id => l_harry_application_id
  , p_xml_data => XMLTYPE('
<APPLICATION_DETAIL>
  <CORRESPONDENCE>
    <TITLE>Mr</TITLE>
    <FORENAME>Harry</FORENAME>
    <SURNAME>Potter</SURNAME>
    <COMPANY_NAME>Hogwarts</COMPANY_NAME>
    <CONTACT_DETAILS>
      <TELEPHONE_NUMBER>+44 (0)20 1234 5678</TELEPHONE_NUMBER>
      <MOBILE_NUMBER>+44 (0)70 1234 5678</MOBILE_NUMBER>
      <EMAIL_ADDRESS>theboywholived@hogmail.com</EMAIL_ADDRESS>
      <ADDRESS>
        <ABS_REC_NUM>17313055</ABS_REC_NUM>
        <FULL_ADDRESS>
          40 YORK STREET
          NORWICH
        </FULL_ADDRESS>
        <POSTCODE>NR2 2AW</POSTCODE>
        <GRID_EASTING>622127</GRID_EASTING>
        <GRID_NORTHING>307895</GRID_NORTHING>
      </ADDRESS>
    </CONTACT_DETAILS>
  </CORRESPONDENCE>
  <SITE_DETAILS>
    <SITE_ADDRESS>
      <POSTCODE>NR2 2AW</POSTCODE>
      <ADDRESS>
        <ABS_REC_NUM>17313055</ABS_REC_NUM>
        <FULL_ADDRESS>40 YORK STREET NORWICH</FULL_ADDRESS>
        <POSTCODE>NR2 2AW</POSTCODE>
        <GRID_EASTING>622127</GRID_EASTING>
        <GRID_NORTHING>307895</GRID_NORTHING>
      </ADDRESS>
    </SITE_ADDRESS>
    <WORK_PLAN>
      <START_DATE>2020-06-30</START_DATE>
      <DETAIL_OF_WORK>Upgrade of cupboard under stairs.</DETAIL_OF_WORK>
    </WORK_PLAN>
  </SITE_DETAILS>
  <DOCUMENTS/>
</APPLICATION_DETAIL>'
    )
  );
  
  l_darth_application_id := trainingmgr.xx_plan_app.create_new_application (
    p_application_type_id => l_new_application_type_id
  );
  
  l_darth_detail_id := trainingmgr.xx_plan_app.update_application_data(
    p_application_id => l_darth_application_id
  , p_xml_data => XMLTYPE('
<APPLICATION_DETAIL>
  <CORRESPONDENCE>
    <TITLE>Dr</TITLE>
    <FORENAME>Darth</FORENAME>
    <SURNAME>Vader</SURNAME>
    <COMPANY_NAME>Empire Construction</COMPANY_NAME>
    <CONTACT_DETAILS>
      <TELEPHONE_NUMBER>+44 (0)20 4444 4444</TELEPHONE_NUMBER>
      <MOBILE_NUMBER/>
      <EMAIL_ADDRESS>iamyourfather@darkside.net</EMAIL_ADDRESS>
      <ADDRESS>
        <ABS_REC_NUM>17313055</ABS_REC_NUM>
        <FULL_ADDRESS>40 YORK STREET
NORWICH</FULL_ADDRESS>
        <POSTCODE>NR2 2AW</POSTCODE>
        <GRID_EASTING>622127</GRID_EASTING>
        <GRID_NORTHING>307895</GRID_NORTHING>
      </ADDRESS>
    </CONTACT_DETAILS>
  </CORRESPONDENCE>
  <SITE_DETAILS>
    <SITE_ADDRESS>
      <POSTCODE>NR2 2AW</POSTCODE>
      <ADDRESS>
        <ABS_REC_NUM>17313055</ABS_REC_NUM>
        <FULL_ADDRESS>40 YORK STREET NORWICH</FULL_ADDRESS>
        <POSTCODE>NR2 2AW</POSTCODE>
        <GRID_EASTING>622127</GRID_EASTING>
        <GRID_NORTHING>307895</GRID_NORTHING>
      </ADDRESS>
    </SITE_ADDRESS>
    <WORK_PLAN>
      <START_DATE>2020-01-23</START_DATE>
      <DETAIL_OF_WORK>Death Star. A space station capable of destroying a planet.</DETAIL_OF_WORK>
    </WORK_PLAN>
  </SITE_DETAILS>
  <DOCUMENTS/>
</APPLICATION_DETAIL>'
    )
  );
  
  l_frodo_application_id := trainingmgr.xx_plan_app.create_new_application (
    p_application_type_id => l_upgrade_application_type_id
  );
  
  l_frodo_detail_id := trainingmgr.xx_plan_app.update_application_data(
    p_application_id => l_frodo_application_id
  , p_xml_data => XMLTYPE('
<APPLICATION_DETAIL>
  <CORRESPONDENCE>
    <TITLE>Mr</TITLE>
    <FORENAME>Frodo</FORENAME>
    <SURNAME>Baggins</SURNAME>
    <COMPANY_NAME>Baggins and Co.</COMPANY_NAME>
    <CONTACT_DETAILS>
      <TELEPHONE_NUMBER>+44 (0)20 8765 4321</TELEPHONE_NUMBER>
      <MOBILE_NUMBER/>
      <EMAIL_ADDRESS>ringbearer2@middleearthonline.com</EMAIL_ADDRESS>
      <ADDRESS>
        <ABS_REC_NUM>17313055</ABS_REC_NUM>
        <FULL_ADDRESS>40 YORK STREET
NORWICH</FULL_ADDRESS>
        <POSTCODE>NR2 2AW</POSTCODE>
        <GRID_EASTING>622127</GRID_EASTING>
        <GRID_NORTHING>307895</GRID_NORTHING>
      </ADDRESS>
    </CONTACT_DETAILS>
  </CORRESPONDENCE>
  <SITE_DETAILS>
    <SITE_ADDRESS>
      <POSTCODE>NR2 2AW</POSTCODE>
      <ADDRESS>
        <ABS_REC_NUM>17313055</ABS_REC_NUM>
        <FULL_ADDRESS>40 YORK STREET NORWICH</FULL_ADDRESS>
        <POSTCODE>NR2 2AW</POSTCODE>
        <GRID_EASTING>622127</GRID_EASTING>
        <GRID_NORTHING>307895</GRID_NORTHING>
      </ADDRESS>
    </SITE_ADDRESS>
    <WORK_PLAN>
      <START_DATE>2020-04-22</START_DATE>
      <DETAIL_OF_WORK>Rebuilding the shire.</DETAIL_OF_WORK>
    </WORK_PLAN>
  </SITE_DETAILS>
  <DOCUMENTS/>
</APPLICATION_DETAIL>'
    )
  );
  
  l_frodo_detail_id := trainingmgr.xx_plan_app.update_application_data(
    p_application_id => l_frodo_application_id
  , p_xml_data => XMLTYPE('
<APPLICATION_DETAIL>
  <CORRESPONDENCE>
    <TITLE>Mr</TITLE>
    <FORENAME>Frodo</FORENAME>
    <SURNAME>Baggins</SURNAME>
    <COMPANY_NAME>Baggins and Co.</COMPANY_NAME>
    <CONTACT_DETAILS>
      <TELEPHONE_NUMBER>+44 (0)20 8765 4321</TELEPHONE_NUMBER>
      <MOBILE_NUMBER/>
      <EMAIL_ADDRESS>ringbearer2@middleearthonline.com</EMAIL_ADDRESS>
      <ADDRESS>
        <ABS_REC_NUM>17313055</ABS_REC_NUM>
        <FULL_ADDRESS>40 YORK STREET
NORWICH</FULL_ADDRESS>
        <POSTCODE>NR2 2AW</POSTCODE>
        <GRID_EASTING>622127</GRID_EASTING>
        <GRID_NORTHING>307895</GRID_NORTHING>
      </ADDRESS>
    </CONTACT_DETAILS>
  </CORRESPONDENCE>
  <SITE_DETAILS>
    <SITE_ADDRESS>
      <POSTCODE>NR2 2AW</POSTCODE>
      <ADDRESS>
        <ABS_REC_NUM>17313055</ABS_REC_NUM>
        <FULL_ADDRESS>40 YORK STREET NORWICH</FULL_ADDRESS>
        <POSTCODE>NR2 2AW</POSTCODE>
        <GRID_EASTING>622127</GRID_EASTING>
        <GRID_NORTHING>307895</GRID_NORTHING>
      </ADDRESS>
    </SITE_ADDRESS>
    <WORK_PLAN>
      <START_DATE>2020-04-22</START_DATE>
      <DETAIL_OF_WORK>Rebuilding the shire with extra strawberries and cream.</DETAIL_OF_WORK>
    </WORK_PLAN>
  </SITE_DETAILS>
  <DOCUMENTS/>
</APPLICATION_DETAIL>'
    )
  );
END;
/